// app.js@toshiyuki-0.0.0
const Stock = require("./stock.js");
const stocks = [];
const stocksNames = [
  "Cookies",
  "Egg Cartons",
  "Cheese",
  "Canolies",
  "Burgers",
  "French Fries",
  "Potato Chips",
  "Bananas",
  "Apples",
  "Lasagna",
  "Caramel",
  "Whoppers",
  "Big Macs",
];

for (let i = 0; i < stocksNames.length; i++) stocks.push(new Stock(stocksNames[i], 25, 0));
console.clear();
console.log("Stock Market Simulator @toshiyuki-0.0.0\n");
for (let i = 0; i < stocks.length; i++) {
  let color = "";
  let colorEnd = "";
  let symbol = "";
  if (stocks[i].difference() < 0) symbol = "\x1b[31m↓\x1b[0m ";
  if (stocks[i].difference() > 0) symbol = "\x1b[32m↑\x1b[0m ";
  if (stocks[i].difference() === 0) symbol = "  ";
  if (stocks[i].stockPrice === 0) {
    color = "\x1b[90m";
    colorEnd = "\x1b[39m";
  }

  console.log(symbol + color + stocks[i].name + "\t$" + (stocks[i].stockPrice / 100).toFixed(2) + "\t" + stocks[i].bias + colorEnd);
}

setInterval(() => {
  console.clear();
  console.log("Stock Market Simulator @toshiyuki-0.0.0\n");
  for (let i = 0; i < stocks.length; i++) stocks[i].simulate();
  stocks.sort((a, b) => {return b.stockPrice - a.stockPrice});
  for (let i = 0; i < stocks.length; i++) {
    let color = "";
    let colorEnd = "";
    let symbol = "";
    if (stocks[i].difference() < 0) symbol = "\x1b[31m↓\x1b[39m ";
    if (stocks[i].difference() > 0) symbol = "\x1b[32m↑\x1b[39m ";
    if (stocks[i].difference() === 0) symbol = "  ";
    if (stocks[i].stockPrice === 0) {
      color = "\x1b[90m";
      colorEnd = "\x1b[39m";
    }

    console.log(symbol + color + stocks[i].name + "\t$" + (stocks[i].stockPrice / 100).toFixed(2) + "\t" + stocks[i].bias + colorEnd);
  }
}, 500);
