// stock.js@toshiyuki-0.0.0
module.exports = class Stock {
    constructor(name, margin, stockPrice) {
        this.bias = 49; // Chances are 0-99, so 49 is 50%
        this.margin = margin;
        this.name = name;
        this.stockHistory = [stockPrice];
        this.stockPrice = stockPrice;
    }

    // Change the price of the stock.
    simulate() {
        // The chances are 50% to lower or raise.
        let change = Math.floor(Math.random() * this.margin);
        let changeBias = Math.floor(Math.random() * 3) + 1;
        let random = Math.floor(Math.random() * 100);
        let randomBias = Math.floor(Math.random() * 2);
        if (random >= 0 && random <= this.bias) this.stockPrice += change; else this.stockPrice -= change;
        if (randomBias === 1) this.bias += changeBias; else this.bias -= changeBias;
        if (this.stockPrice < 0) this.stockPrice = 0;
        if (this.bias < 0) this.bias = 0;
        if (this.bias > 99) this.bias = 99;
        this.stockHistory.push(this.stockPrice);
        return this.stockPrice;
    }

    // Return the difference of the latest stocks
    difference() {
        if (this.stockHistory.length > 1) {
            let diff0 = this.stockHistory[this.stockHistory.length - 1];
            let diff1 = this.stockHistory[this.stockHistory.length - 2];
            return diff0 - diff1;
        } else return 0;
    }
};
